/*****************************************
 * Small Assignment 2: Processing and Turtle Geometry
 * Name:    Ben Liu
 * E-mail:  bliu1013@unm.edu
 * Course:      CS491, Computational Fabrication
 * Submitted:    2/1/2022
 *
 * This program displays several different images.
* To plot a polar plot, press the p key.
* To draw a circle with a turtle, press the t key.
* To draw a flower, press the f key.
* To draw a cool turtle path, press the c key.
***********************************************/

import Turtle.*;

Turtle turtle;

PolarPlot p;
Circle t;
Flower f;
TurtlePlots c;

void setup() {
  size(800, 800);
  background(#61A5FC);
  
  p = new PolarPlot();
  t = new Circle();
  f = new Flower();
  c = new TurtlePlots();
  
  turtle = new Turtle(this);
  turtle.drawTurtle();
}

void draw() {
  
}

void keyPressed() {
  //Reset the picture every time
  background(#61A5FC);
  stroke(0);
  strokeWeight(1);

  if (key == 'p') {
    println("Drawing Polar Plot");
    p.drawPlot();
    save("Polar.jpg");
  }
  else if (key == 't') {
    println("Drawing Turtle-centered Circle");
    t.drawCircle(turtle, 100);
    save("Circle.jpg");
  }
  else if (key == 'f') {
    println("Drawing Flower Plot");
    f.drawFlower(turtle, 20);
    save("Flower.jpg");
  }
  else if (key == 'c') {
    println("Drawing Cool Plot");
    c.drawPlot(new Turtle(this));
    save("Turtle.jpg");
  }
 
}
