class Flower {
  float radius = 200;
  float circ;
  
  void drawFlower(Turtle t, float petals) {
    strokeWeight(10);
    stroke(200);
    circ = 2 * PI * radius; //Circumference of the reference circle
    float angle = 360 / petals;
    
    //Make the first petal centered at the top
    t.left(angle/2);
    
    for (int i=0; i<petals; i++) {
      drawPetal(t, angle);  
    }
    
    fill(#FFF700);
    ellipse(width/2, height/2, 50, 50);
  }
  
  
  void drawPetal(Turtle t, float angle) {
    t.forward(radius);
    
    //Calculate radius of the semicircle using the rule of cosines
    float r = sqrt(2*sq(radius) * (1 - cos(radians(angle)))) / 2;
    
    //Calculate circumference
    float c = 2 * PI * r;
    
    //Draw the semicircle
    float a = (180 - angle);
    for (int i=0; i<360-a; i++) {
      t.right(1);
      t.forward(c/360);
    }
    
    t.forward(radius);
    t.right(180);
  }
}
