class PolarPlot {
  float x0, y0;
  
  PolarPlot() {
    x0 = width/2;
    y0 = height/2;
  }
  
  void drawPlot() {
    background(0);
    
    float prevX = -1;
    float prevY = -1;
    
    for (float i=0; i<360; i+=2) {
      stroke(random(50,255));
      float[] coords = getCoords(random(300, 400), i);
      line(x0, y0, coords[0], coords[1]);
      
      if (prevX == -1) {
        prevX = coords[0];
        prevY = coords[1];
      }
      else {
        line(coords[0], coords[1], prevX, prevY);
        prevX = coords[0];
        prevY = coords[1];
      }
      
    }
  }
  
  
  float[] getCoords(float r, float theta) {
    float[] coords = new float[2];
    coords[0] = x0 + r * cos(theta);
    coords[1] = y0 + r * sin(theta);
   
    return coords;
  }
}
