class TurtlePlots {
  Turtle t;
  int drawing = 0;
  
  void drawPlot(Turtle t) {
    switch(drawing % 3) {
      case 0: 
        drawing_1(t, 10, 15);
        break;
      case 1: 
        drawing_2(t);
        break;
      case 2: 
        drawing_3(t);
        break;
    }
    
    drawing++;
  }
  
  void drawing_1(Turtle t, float size, float angle) {
    while (size < 150) {
      t.forward(size);
      t.right(angle);
      size += 0.1;
      angle += 15;
    }
  }
  
  void drawing_2(Turtle t) {
    L_System(t, 10, 60);
  }
  
  void drawing_3(Turtle t) {
    int size = 100;
    int angle = 1;
    
    for (int i=0; i<100; i++) {
      polygonHalt(t, size, angle);
      angle += 1;
      stroke(alpha(i));
    }
  }
  
  
  //Helper functions
  void L_System(Turtle t, int len, int angle) {
    String[][] rules = {{"L", "L+R"}, {"R", "L-R"}, {"+", "+"}, {"-", "-"}};
    String axiom = "L++R++L++R--L--R"; 
    String computedWord = axiom;
    
    //Compute the new word, set to 10 permutations
    for (int i=0; i<10; i++) {
      String tempWord = computedWord;
      computedWord = "";
      
      for (int j=0; j<tempWord.length(); j++) {
        char c = tempWord.charAt(j);
        
        for (String[] r : rules) {
          if (c == r[0].charAt(0)) {
            computedWord += r[1];  
          }
        }
      }
    }
    
    //Now draw
    for (char c : computedWord.toCharArray()) {
      if (c == 'R' || c == 'L') {
        t.forward(len);
      }
      else if (c == '+') {
        t.right(angle);  
      }
      else if (c == '-') {
        t.left(angle);  
      }
    }
  }
  
  void polygonHalt(Turtle t, int size, int angle) {
    int rotation = 0;
    t.forward(size);
    t.right(angle);
    rotation = rotation + angle;
    while(rotation%360 > 0) {
      t.forward(size);
      t.right(angle);
      rotation = rotation + angle;
    }
  }
}
